/*
 File: la_exprsym.cpp
 Date and Time: Fri Jan 30 18:55:13 2015 
*/
#include "la_expr.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_la_expr;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Cla_expr::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rla_expr_:{
       Rla_expr* sym;
     if(re->rule_ == 0){
       sym = new Rla_expr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rla_expr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs1_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr1();
     return;}
    case rhs2_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr2();
     return;}
    case rhs3_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs4_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr4();
     return;}
    case rhs1_Rerr_bad_oper_:{
       Rerr_bad_oper* sym;
     if(re->rule_ == 0){
       sym = new Rerr_bad_oper(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rerr_bad_oper*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rt_:{
       Rt* sym;
     if(re->rule_ == 0){
       sym = new Rt(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rt*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs2_Rt_:{
       Rt* sym;
     if(re->rule_ == 0){
       sym = new Rt(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rt*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs3_Rt_:{
       Rt* sym;
     if(re->rule_ == 0){
       sym = new Rt(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rt*)re->rule_;
     }
    sym->ctor();

     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs1_Rminus_:{
       Rminus* sym;
     if(re->rule_ == 0){
       sym = new Rminus(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rminus*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rplus_:{
       Rplus* sym;
     if(re->rule_ == 0){
       sym = new Rplus(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rplus*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    default: return;
   }
}
